/*
 * 
 * RootKit
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */

#include <includes.h>

#define NAME "Hidesource"
#define DESC "\
'Hidesource' is the name of a popular set of SunOS utilities\n\
that are used by hackers to backdoor a compromised host.\n\
This plugin attempts to check if this kit has been installed\n\
by trying the default username and password which is \n\
wank/wank"

#define COPYRIGHT "no copyright"
#define SUMM "tries to login to the remote system using the default Hidesource password"


struct accounts {
    char * login;
    char * password;
    };
    
char init_telnet_session(int sock);
void send_data(int sock, char * data, int echo);
void send_return(int soc);
int read_line(int sock, char * buf, int len);
int accept_telnet_session(struct arglist * env);
int try_account(struct arglist * env, char * login, char * pass);

PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_ATTACK);
	plug_set_family(desc, "Backdoors");
	return(0);
}


PlugExport int plugin_run(struct arglist * env);
PlugExport int plugin_run(struct arglist * env)
{
                                     
        int i = 0;        
        int code  = 0;                
        if(host_get_port_state(env, 23)<=0)return(0);
        if(!accept_telnet_session(env))return(0);
        if(try_account(env, "wank", "wank"))
        {
         post_hole(env, 23,
"The remote system appears to have the\n\
'Hidesource' backdoor/trojan package installed\n\
which means that the remote system has been\n\
compromised.\n\
Solution: Consult the following CERT document:\n\
Steps for Recovering from a UNIX Root Compromise \n\
\n\
ftp://ftp.cert.org/pub/tech-tips/root_compromise\n");
        }
	
     return(0);
}

char init_telnet_session(int sock)
{ 
 unsigned char iac, code, option;
 

 iac = 255;
 
 while(iac == 255)
 {
   fd_set read;
   struct timeval tv = {5,0};
   
   FD_ZERO(&read);
   FD_SET(sock, &read);
   select(sock+1, &read, NULL, NULL, &tv);
   if(!FD_ISSET(sock, &read))return(-1);
   recv(sock, &iac, 1,0);
   if(iac!=255)break;
   recv(sock, &code, 1,0);
   recv(sock, &option, 1,0);
   if((code == 251)||(code == 252))code = 254; /* WILL or WONT --> DONT */
   else if((code == 253)||(code == 254))code = 252; /* DO or DON'T --> WONT */
   send(sock, &iac, 1,0);
   send(sock,&code, 1,0);
   send(sock, &option, 1,0);
  }
  return(iac);
}

void send_data(int sock, char * data, int echo)
{
 int i = 0;
 unsigned char c;
 while(data[i])
 {
  send(sock, &data[i], 1,0);
  if(echo){recv(sock, &c, 1, 0);}
  i++;
 }
}


void send_return(int soc)
{
 char s[2];
 s[0] = 13;
 s[1] = 0;
 send(soc, s, 2, 0);
 recv(soc, s, 2, 0);
}

int accept_telnet_session(struct arglist * env)
{
 int soc = open_sock_tcp(env, 23);
 char c;
 char * buf;
 fd_set read;
 struct timeval tv = {3,0};
 int ok = 0;
 int empty = 0;

 if(soc<0)return(0);
 c = init_telnet_session(soc);
 if(c < 0)return(0);
 buf = emalloc(2048);
 buf[0]=c;
 
 while(!empty)
 {
 FD_ZERO(&read);
 FD_SET(soc, &read);
 tv.tv_sec = 3;
 empty = !((select(soc+1, &read,NULL, NULL, &tv))>0);
 if(!empty)
  {
  recv(soc, buf+1, 2048, 0);
  if(strstr(buf, "login:"))ok = 1;
  }
 }
 shutdown(soc, 2);
 close(soc);
 efree(&buf);
 return(ok);
}



int try_account(struct arglist * env, char * login, char * pass)
{
 int soc = open_sock_tcp(env, 23);
 char c;
 char * buf;
 fd_set read, rd;
 struct timeval tv = {1,0};
 int ok = 0;
 int empty = 0;
 int i;
 if(soc<0)return(0);
 c = init_telnet_session(soc);
 if(c < 0)return(0);
 buf = emalloc(2048);
 buf[0]=c;
 
 while(!empty)
 {
 FD_ZERO(&read);
 FD_SET(soc, &read);
 tv.tv_sec = 1;
 empty = !((select(soc+1, &read,NULL, NULL, &tv))>0);
 if(!empty)
  {
  recv(soc, buf+1, 2048, 0);
  if(strstr(buf, "login:"))ok = 1;
  }
 }
 if(!ok)
 {
  efree(&buf);
  shutdown(soc, 2);
  close(soc);
  return(0);
 }
 send_data(soc, login, 0);
 send_return(soc);
 bzero(buf, 2048);
 FD_ZERO(&rd);
 FD_SET(soc, &rd);
 tv.tv_sec = 1;
 while(select(soc+1, &rd, NULL, NULL, &tv)>0)
 {
  tv.tv_sec = 1;
  recv(soc, buf, 2048, 0);
 }
 
 if(strlen(buf)<5)return(0);
 for(i=0;i<strlen(buf);i++)buf[i] = tolower(buf[i]);
 if(!strstr(buf, "word:")&&!strstr(buf, "key")&&!strstr(buf, "denied"))
 {
  char * c = strchr(buf, '\n');
  char * c2;
  if(c)c2 = strchr(c+1, '\n');
  if(c)
  {
  efree(&buf);
  shutdown(soc, 2);
  return(1);
  }
 }
 
 send_data(soc, pass, 0);
 send_return(soc);
 bzero(buf, 2048);
 recv(soc, buf, 2048, 0);
 for(i=0;i<strlen(buf);i++)buf[i] = tolower(buf[i]);
 if(!(strstr(buf,"word:"))&&(!strstr(buf, "incorrect"))&&(
     (!strstr(buf, "denied")))&&(strlen(buf)>5)&&
     (((!strstr(buf, "ogin:"))||((strstr(buf, "ast login")))))){
     char * c = strchr(buf, '\n');
     char * c2;
     
     if(c)c2 = strchr(c+1, '\n');
     if(c)
     {
     efree(&buf);
     shutdown(soc, 2);
     return(1);
     }
    }
  efree(&buf);
  shutdown(soc, 2);
  return(0);
}
  
   
 
 
