/*
 * 
 * NetBus
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>
#define NAME "NetBus"
#define DESC "\
NetBus is a trojan horse designed to take the\n\
control of a Win 95/98/NT computer. \n\
This plugin detects if it is installed...\n\
Risk factor : medium/high"
#define COPYRIGHT "no copyright"
#define SUMM "detects if NetBus is running on the remote host"

PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "Backdoors");
	return(0);
}


PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{	
	int i;
        
      
	if((host_get_port_state(args, 12345)>0)&&
	   (host_get_port_state(args, 12346)>0))
	{
	 char * buf = emalloc(4096);
	 char * msg;
	 int soc;
	 
         if((soc = open_sock_tcp(args, 12345))>0)
         {
          recv(soc, buf, 30, 0);
          if(strstr(buf, "NetBus"))
          {
           char * version = strchr(buf, ' ');
           char * end = version?strchr(version+1, ' '):NULL;
           char * report = emalloc(300);
	   int soc2;
           if(end)end[0]=0;
           
           soc2 = open_sock_tcp(args, 12346);
	   if(soc2 > 0)sprintf(report, 
"NetBus %s is installed on the remote\n\
host. This means that an intruder\n\
can take the control of the remote\n\
host and that it has been compromised.\n\
Solution : see \n\
http://members.spree.com/NetBus/remove_1.html\n\
and\n\
http://members.spree.com/NetBus/remove_2.html\n\
to find out how to delete it", version ? version+1:"");
	  else close(soc2);
	  post_hole(args, i, report);
          efree(&report);
          }
         }
	shutdown(soc, 2);
	close(soc);
        efree(&buf);
	}
       return(0);
}

