/*
 * 
 * uploader_exe
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>
#define NAME "uploader.exe problem"
#define DESC "O'reilly's webserver  'website' contains a demopackage\n\
that contains the cgi-program uploader.exe. It's possible to use\n\
it to upload CGI-programs on the remote WebServer thus allowing an\n\
intruder to execute arbitrary commands remotely\n\
Platforms affected : WindowsNT, Windows95\n\
Risk factor : High"
#define COPYRIGHT "found by Herman de Vette"
#define SUMM "uploads a file on the remote WebSite server"

int is_http_command_ok(struct arglist * env, char * comm);




PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_ATTACK);
	plug_set_family(desc, "CGI abuses");
	plug_set_dep(desc, "find_service.nes");
	return(0);
}





PlugExport int plugin_run(struct arglist * env);
PlugExport int plugin_run(struct arglist * env)
{
	int port = (int)plug_get_key(env, "Services/www");
	if(!port)port = 80;
	if(host_get_port_state(env, port)<=0)return(0);
  	if(is_cgi_installed(env, "/cgi-win/uploader.exe"))
        {
         post_hole(env, port, 
"It may be possible for a remote user to upload one's CGI scripts\n\
and to execute them on the remote web server\n\
Solution : remove the CGI 'uploader.exe'");
        }
	return(0);
}
