/*
 *          Copyright (c) mjh-EDV Beratung, 1996-1999
 *     mjh-EDV Beratung - 63263 Neu-Isenburg - Rosenstrasse 12
 *          Tel +49 6102 328279 - Fax +49 6102 328278
 *                Email info@mjh.teddy-net.com
 *
 *       Author: Jordan Hrycaj <jordan@mjh.teddy-net.com>
 *
 *   $Id: peks-rpc.h,v 1.2 1999/03/31 17:59:56 renaud Exp $
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __PEKS_RPC_H__
#define __PEKS_RPC_H__

#ifndef XPUB
#define XPUB /* extract public interface */
#endif

#ifdef __PEKS_INTERNAL_H__
typedef struct _prpc {
  int fd, tid ;

  /* link to the call back catcher data aerea */
  void *tdata ;

} prpc ;

#else
XPUB typedef struct { char opaq [1] ; } prpc ;
#endif

XPUB 
XPUB /* public functions in peks-rpc.c */
XPUB 
XPUB extern prpc *prpc_accept (int fd, prpc* desc);
XPUB extern prpc *prpc_connect (int fd, prpc* desc);
XPUB   

#endif /* __PEKS_RPC_H__ */
