/*
 *          Copyright (c) mjh-EDV Beratung, 1996-1999
 *     mjh-EDV Beratung - 63263 Neu-Isenburg - Rosenstrasse 12
 *          Tel +49 6102 328279 - Fax +49 6102 328278
 *                Email info@mjh.teddy-net.com
 *
 *   Author: Jordan Hrycaj <jordan@mjh.teddy-net.com>
 *
 *   $Id: version.h,v 1.3 1999/03/31 17:59:58 renaud Exp $
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   PEKS - private exponent key stuff for Diffie Hellman and El Gamal
 */

#ifndef __VERSION_H__
#define __VERSION_H__

#define PEKSMAJOR   0
#define PEKSMINOR   6

/* printable release strings */
#define _tostr(s)         # s
#define _identstr(s,M,m)  s "/" _tostr (M) "." _tostr (m)
#define PEKS_VERSION      _identstr ("peks", PEKSMAJOR, PEKSMINOR)
#define PRPC_VERSION      _identstr ("prpc", PEKSMAJOR, PEKSMINOR)
#define  ELG_VERSION      _identstr  ("elg", PEKSMAJOR, PEKSMINOR)
#define   PEKS_MAGIC      "jordan's test"

#endif /* __VERSION_H__ */
