/*
 * 
 * ExAir DoS
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>
#define NAME "ExAir possible DoS"
#define DESC "\
This plugin is for those that have Internet Information Server 4 installed\n\
with the IIS sample site \"ExAir\".\n\
\n\
There are three Active Server Pages that, if called directly without the\n\
default ExAir page and associated dlls ever having been loaded into the IIS\n\
memory space, will hang and eventually time out after 90 secs - the default\n\
script timeout period. Whilst in this state, processor usage increases to\n\
100% and the server becomes very sluggish.\n\n\
This plugin does not perform this denial of service attack\n\
Risk factor : High"
#define COPYRIGHT "mnemonix <mnemonix@GLOBALNET.CO.UK>"
#define SUMM "determines the presence of some ExAir scripts"

PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_ATTACK);
	plug_set_dep(desc, "find_service.nes");
	plug_set_family(desc, "CGI abuses");
	return(0);
}

short is_file_installed(struct arglist *, char *);
PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{
	int port = (int)plug_get_key(args, "Services/www");
	if(!port)port = 80;
	if(!host_get_port_state(args, port))return(0);
	if(is_cgi_installed(args, "/iissamples/exair/search/advsearch.asp"))
        {
         post_hole(args, port, "\
The asp page 'advsearch', part of ExAir, may allow an attacker\n\
to perform a Denial of Service attack against this server\n\
Solution : delete this page");
	}
        
        if(is_cgi_installed(args, "/iissamples/exair/search/query.asp"))
        {
         post_hole(args, port, "\
The asp page query, part of ExAir, may allow an attacker\n\
to perform a Denial of Service attack against this server\n\
Solution : delete this page");
	}
        
        if(is_cgi_installed(args, "/iissamples/exair/search/search.asp"))
        {
         post_hole(args, port, "\
The asp page search, part of ExAir, may allow an attacker\n\
to perform a Denial of Service attack against this server\n\
Solution : delete this page");
	}
        
        
	return(0);
}
