/*
 * 
 * mspws
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>
#define NAME "Microsoft Personnal Web Server '.....'"
#define DESC "\
It is possible to list and download any file on a remote\n\
windows 95 host that has MS PWS installed by requesting\n\
'......' which will list the root directory\n\
Risk factor : high"
#define COPYRIGHT "discovered by Sean Coates <sean@SPATULA.ML.ORG>"
#define SUMM "Attempts to get the root listing of the remote web server"

PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_ATTACK);
	plug_set_family(desc, "Remote file access");
	plug_set_dep(desc, "find_service.nes");
	return(0);
}


PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{	
	int port = (int)plug_get_key(args, "Services/www");
	if(!port)port = 80;
	
	if(((host_get_port_state(args, port))>0)&&
		is_cgi_installed(args, "/........."))
	  post_hole(args,port , "\
It is possible to get the remote\n\
root listing (and it is possible to\n\
download the listed file) on the remote\n\
web server by requesting '.......'\n\
Solution: contact your vendor for a patch\n\
or upgrade your web server");
	 

	return(0);
}

